読者です 読者をやめる 読者になる 読者になる

あれもPython,これもPython

Pythonで世界を包みたい

Pythonで例外処理を扱う(try,except)

プログラミングを始めたばかりのころ、
何に使うのかよくわからなかったものに、
例外処理があります。
(エラー自体起こさないようにすればいいじゃんと思ってた)

最近モジュールつくりたいなー、
とか思うように成ったので、
ちゃんと復習。

基本

try:
    #処理
except:
    #tryで例外発生時の処理

ひとまずこれだけです。

例外を発生させたい時

自分で関数などを作っていて、
エラーを発生させたい時に使用します。

if A is None:
    raise ValueError("A is None")
# AがnoneだとValueError: testを発生させる

例外の種類は色々ありますが

  • TypeError:型エラー
  • ValueError:値のエラー
  • RuntimeError:ランタイムエラー
  • KeyError:辞書等のキーエラー [文字列]の際
  • IndexError:リスト等のキーエラー [数字]の際

あたりをとりあえず覚えておけばいいのではないでしょうか。

発生したエラーをcatchする

try:
    処理
except KeyError as instance:
    print instance

とやると、KeyError発生時のエラーを受け取ることが可能になります。